// hlavickove subory *******************************************************
#include "../includes.h"
// vlastny .h subor
#include "psystem.h"

// vytvorenie systemu ******************************************************
int Cpsystem::create(GLuint N,GLfloat SPEED,GLfloat TIME,GLfloat SIZE,GLuint TID)
{
 // pamatove miesto pre system
 ps=new particle_system;
 if (ps==NULL) {
  printf("Chyba alokacie pamate pre system castic!\n"); return(1);
 }
 // naplnenie systemu udajmi
 ps->num=N;
 ps->s_speed=SPEED;
 ps->s_time=TIME;
 ps->s_size=SIZE;

 ps->tex_id=TID;
 ps->s_color.set(1.0f,1.0f,1.0f,1.0f);

 // pamatove miesto pre udaje jednotlivych castic
 ps->pos=new vec3[N*sizeof(vec3)];
 if (ps->pos==NULL) {
  printf("Chyba alokacie pamate pre system castic!\n");
  DELETEP(ps); return(1);
 }
 ps->rot=new GLfloat[N*sizeof(GLfloat)];
 if (ps->rot==NULL) {
  printf("Chyba alokacie pamate pre system castic!\n");
  DELETEA(ps->pos); DELETEP(ps); return(1);
 }
 ps->speed=new vec3[N*sizeof(vec3)];
 if (ps->speed==NULL) {
  printf("Chyba alokacie pamate pre system castic!\n");
  DELETEA(ps->rot); DELETEA(ps->pos); DELETEP(ps); return(1);
 }
 ps->time=new GLfloat[N*sizeof(GLfloat)];
 if (ps->time==NULL) {
  printf("Chyba alokacie pamate pre system castic!\n");
  DELETEA(ps->speed); DELETEA(ps->rot); DELETEA(ps->pos); DELETEP(ps); return(1);
 }
 // naplnenie zoznamov udajmi
 loopi(N) {
  ps->pos[i].set(0.0f,0.0f,0.0f);
  ps->rot[i]=0.0f;
  ps->speed[i].set(0.0f,0.0f,0.0f);
  ps->time[i]=ranged_random(ps->s_time/2.0f,ps->s_time);
 }

 ps->F.set(0.0f,1.0f,0.0f);

 return(0);
}

// reset "zivota" castice systemu ******************************************
void Cps_fire::reset_timer(int I)
{
 ps->pos[I]=ps->s_pos;
 ps->rot[I]=360.0f*ranged_random(0.0f,1.0f);
 ps->speed[I].set(noise(ps->s_speed),noise(ps->s_speed),noise(ps->s_speed));
 ps->time[I]=ranged_random(ps->s_time/2.0f,ps->s_time);
}

// priebeh "zivota" systemu ************************************************
void Cps_fire::update(GLfloat dT)
{
 dT/=5.0f;
 loopi(ps->num) {
  ps->speed[i]+=ps->F*dT;
  // castice sa priblizuju k vertikalnej osi
  if (ps->pos[i].x>ps->s_pos.x) ps->speed[i].x-=10.0f*dT; else ps->speed[i].x+=10.0f*dT;
  if (ps->pos[i].z>ps->s_pos.z) ps->speed[i].z-=10.0f*dT; else ps->speed[i].z+=10.0f*dT;
  // zmena polohy castice
  ps->pos[i]+=ps->speed[i]*dT;
  // znizovanie casu "zivota" castice
  ps->time[i]-=dT;
  // po ukonceni casu "zivota" sa "zivot" castice resetuje
  if (ps->time[i]<0.0f) reset_timer(i);
 }
}

// vykreslenie systemu *****************************************************
void Cps_fire::draw(float M)
{
 glDepthMask(0);

 glBlendFunc(GL_ONE,GL_ONE);
 glEnable(GL_BLEND);

 // ziskanie modelview matice
 glGetFloatv(GL_MODELVIEW_MATRIX,mvmat);
 // billboarding castic systemu
 // sirka castice
 mx.set(M,0.0f,0.0f);
 s.x=(mx.x*mvmat[0]+mx.y*mvmat[1]+mx.z*mvmat[2]);
 s.y=(mx.x*mvmat[4]+mx.y*mvmat[5]+mx.z*mvmat[6]);
 s.z=(mx.x*mvmat[8]+mx.y*mvmat[9]+mx.z*mvmat[10]);
 mx.set(s.x,s.y,s.z);
 // vyska castice
 my.set(0.0f,1.0f,0.0f);
 s.x=(my.x*mvmat[0]+my.y*mvmat[1]+my.z*mvmat[2]);
 s.y=(my.x*mvmat[4]+my.y*mvmat[5]+my.z*mvmat[6]);
 s.z=(my.x*mvmat[8]+my.y*mvmat[9]+my.z*mvmat[10]);
 my.set(s.x,s.y,s.z);

 // pripojenie textury
 glBindTexture(GL_TEXTURE_2D,ps->tex_id);
 // vykreslenie vsetkych castic systemu
 loopi(ps->num) {
  glPushMatrix();
  glTranslatef(ps->pos[i].x,ps->pos[i].y,ps->pos[i].z);
  glRotatef(ps->rot[i],mvmat[2],mvmat[6],mvmat[10]);
  // velkost castice
  glScalef(ps->s_size,ps->s_size,ps->s_size);
  // farba castice
  if (ps->time[i]<ps->s_time/4.0f) { // iba dym
   f=ps->time[i]/ps->s_time; c.set(f,f,f,1.0f);
  }
  else {                             // povodna farba
   c.set(ps->s_color.x*(ps->time[i]/ps->s_time),
         ps->s_color.y*(ps->time[i]/ps->s_time),
         ps->s_color.z*(ps->time[i]/ps->s_time),1.0f);
  }
  glColor4fv(c.get_data());
  // castica sa vykresli ako pas trojuholnikov - vytvori stvorec
  glBegin(GL_TRIANGLE_STRIP);
   glTexCoord2f(0.0f,1.0f); glVertex3f(-mx.x-my.x,-mx.y-my.y,-mx.z-my.z);
   glTexCoord2f(1.0f,1.0f); glVertex3f( mx.x-my.x, mx.y-my.y, mx.z-my.z);
   glTexCoord2f(0.0f,0.0f); glVertex3f(-mx.x+my.x,-mx.y+my.y,-mx.z+my.z);
   glTexCoord2f(1.0f,0.0f); glVertex3f( mx.x+my.x, mx.y+my.y, mx.z+my.z);
  glEnd();
  glPopMatrix();
 }

 glDisable(GL_BLEND);

 glDepthMask(1);

 glColor4f(1.0f,1.0f,1.0f,1.0f); // standardna farba
}

// reset "zivota" castice systemu ******************************************
void Cps_steam::reset_timer(int I)
{
 ps->pos[I]=ps->s_pos;
 ps->rot[I]=360.0f*ranged_random(0.0f,1.0f);
 ps->speed[I].set(emi.x*noise(ps->s_speed),emi.y*noise(ps->s_speed),emi.z*noise(ps->s_speed));
 ps->time[I]=ranged_random(ps->s_time/2.0f,ps->s_time);
}

// priebeh "zivota" systemu ************************************************
void Cps_steam::update(GLfloat dT)
{
 dT/=1.5f;
 loopi(ps->num) {
  ps->speed[i]+=ps->F*dT;
  // zmena polohy castice
  ps->pos[i]+=ps->speed[i]*dT;
  // znizovanie casu "zivota" castice
  ps->time[i]-=dT;
  // po uplynuti casu "zivota" sa "zivot" castice resetuje
  if (ps->time[i]<0.0f) reset_timer(i);
 }
}

// vykreslenie systemu *****************************************************
void Cps_steam::draw(float M)
{
 glDepthMask(0);

 glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
 glEnable(GL_BLEND);

 // ziskanie modelview matice
 glGetFloatv(GL_MODELVIEW_MATRIX,mvmat);
 // billboarding castic systemu
 // sirka castice
 mx.set(M,0.0f,0.0f);
 s.x=(mx.x*mvmat[0]+mx.y*mvmat[1]+mx.z*mvmat[2]);
 s.y=(mx.x*mvmat[4]+mx.y*mvmat[5]+mx.z*mvmat[6]);
 s.z=(mx.x*mvmat[8]+mx.y*mvmat[9]+mx.z*mvmat[10]);
 mx.set(s.x,s.y,s.z);
 // vyska castice
 my.set(0.0f,1.0f,0.0f);
 s.x=(my.x*mvmat[0]+my.y*mvmat[1]+my.z*mvmat[2]);
 s.y=(my.x*mvmat[4]+my.y*mvmat[5]+my.z*mvmat[6]);
 s.z=(my.x*mvmat[8]+my.y*mvmat[9]+my.z*mvmat[10]);
 my.set(s.x,s.y,s.z);

 // pripojenie textury
 glBindTexture(GL_TEXTURE_2D,ps->tex_id);
 // vykreslenie vsetkych castic systemu
 loopi(ps->num) {
  glPushMatrix();
  glTranslatef(ps->pos[i].x,ps->pos[i].y,ps->pos[i].z);
  glRotatef(ps->rot[i],mvmat[2],mvmat[6],mvmat[10]);
  // velkost castice
  f=ps->s_size+((ps->s_time-ps->time[i]));
  glScalef(f*f,f*f,f*f);
  // farba castice
  f=ps->time[i]/ps->s_time;
  c.set(ps->s_color.x*f,ps->s_color.y*f,ps->s_color.z*f,f+0.1f);
  glColor4fv(c.get_data());
  // castica sa vykresli ako pas trojuholnikov - vytvori stvorec
  glBegin(GL_TRIANGLE_STRIP);
   glTexCoord2f(0.0f,1.0f); glVertex3f(-mx.x-my.x,-mx.y-my.y,-mx.z-my.z);
   glTexCoord2f(1.0f,1.0f); glVertex3f( mx.x-my.x, mx.y-my.y, mx.z-my.z);
   glTexCoord2f(0.0f,0.0f); glVertex3f(-mx.x+my.x,-mx.y+my.y,-mx.z+my.z);
   glTexCoord2f(1.0f,0.0f); glVertex3f( mx.x+my.x, mx.y+my.y, mx.z+my.z);
  glEnd();
  glPopMatrix();
 }

 glDisable(GL_BLEND);

 glDepthMask(1);

 glColor4f(1.0f,1.0f,1.0f,1.0f); // standardna farba
}
